           (*-------------------------------------------*
            |  The Dining Mathematicians in Csp-Prover  |
            |               August 2004                 |
            |             December 2004 (modified)      |
            |        Yoshinao Isobe (AIST JAPAN)        |
            *-------------------------------------------*)

theory DM13_Seq_Sys = DM12_Seq_Sys:

(*****************************************************************

         1. proves Seq =F Sys
         2.
         3. 
         4. 

 *****************************************************************)

(*** Seq_TH0_Eat1 ***)

lemma Seq_TH0_Eat1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_TH0_Eat1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_TH0_Eat1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_TH0_Eat1

(*** Seq_Eat0_TH1 ***)

lemma Seq_Eat0_TH1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_Eat0_TH1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_Eat0_TH1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_Eat0_TH1

(*** Seq_TH0_TH1 ***)

lemma Seq_TH0_TH1:
  "LET SysDef IN (Rewrite (SeqDef (Seq_TH0_TH1 n)) By Seq_to_Sys) =F
   LET SysDef IN Seq_to_Sys (Seq_TH0_TH1 n)"
apply (case_tac "ODD n")
apply (tactic {* csp_simp_add_tac "unfold_SYS_rules" 1 *})
done

lemmas SEQ_rules = SEQ_rules Seq_TH0_TH1

(*********************************************************
                  ALL n. Seq n =sf SYS n
 *********************************************************)

lemma Seq_eq_Sys: "Seq n =F Sys n"
apply (simp add: Seq_def Sys_def)
apply (rule csp_fp_induct[of _ _ _ "Seq_to_Sys"])
apply (simp_all)
apply (induct_tac C)
apply (simp add: SEQ_rules del: SeqDef.simps Seq_to_Sys.simps)+
done

end
